*       Zapis parametru do INI souboru
*

*       Vraci   .T./.F. podle toho, jestli se povedlo
*
*       syntaxe INI souboru:=
*       ; poznamkovy radek
*       * poznamkovy radek
*       [jmeno sekce]	; poznamka
*       klic-parametru [=] hodnota-parametru       ; poznamka
*       klic-parametru [=] hodnota-parametru       * poznamka

*       klic-parametru  nesmi obsahovat mezery nebo tabulatory, velka/mala pisemna jsou rovnocenna
*       hodnota-parametru       obsahuje-li ; nebo *  musi byt cela hodnota
*																uzavrena v uvozovkach " "   ' '
*       zbytek radku vpravo od znaku poznamky (;*) se ignoruje


FUNCTION PutIniPar(pcIniFile, pcParName, pcSectName, pxValue)
LOCAL xxReturnValue, xcSectName, xcParName, xnLines, xlAppend, xlSectionFound, xnSectionPos, xcSection, xnI, xcR, xnPosS, xnPosR, xcOrigLineKey, xcLineKey
LOCAL ARRAY xaLines(1)

*	pcIniFile		jmeno INI souboru. Neni-li nalezen, zalozi se		POVINNE
*	pcParName		jmeno (klic) parametru													POVINNE
*	pcSectName	jmeno (klic) sekce															POVINNE
*	pxValue			zapisovana hodnota															default=""

#DEFINE mkComment       "*;"
#DEFINE mkStrBorder ["']
#DEFINE mkSectLeft  "["
#DEFINE mkSectRight "]"
#DEFINE CRLF	chr(13)+chr(10)


xxReturnValue=.F.
IF PCount() < 3             && nejsou zadany vsechny hodnoty, ven
	return xxReturnValue
ENDIF
IF empty(pcSectName)		&& neni zadana sekce
	return xxReturnValue
ENDIF
IF empty(pcParName)		&& neni zadany klic parametru
	return xxReturnValue
ENDIF
xcSectName=Upper(Alltrim(pcSectname))
xcParName=Upper(Alltrim(pcParName))
pcIniFile=DefaultExt(pcIniFile, [ini])
IF .not.file(pcIniFile)			&& INIfile nenalezen, zalozit
	StrToFile([; INIfile created by program ]+TtoC(datetime())+CRLF+CRLF, pcIniFile, .F.)
ENDIF
pxValue=Alltrim(Transform(iif(empty(pxValue), [], pxValue)))			&& prevod pxValue na retezec

xnLines=ALines(xaLines, FileToStr(pcIniFile), .T.)
xlAppend=.T.
xlSectionFound=.F.
xnSectionPos=0
xcSection=""

FOR xnI=1 to xnLines					&& hledani sekce a parametru

xcR=ChrTran(Alltrim(xaLines[xnI]), chr(9), " ")       && tabulator -> space
If empty(xcR)			&& radek je prazdny
	loop
EndIf

If left(xcR, 1) $ mkComment			&& poznamka, cist dalsi radek
	loop
EndIf

xnPosS=at(" ", xcR)			&& posice 1. mezery nebo 0
xnPosR=at("=", xcR)				&& posice 1. rovnitka nebo 0
Do case
		case (xnPosS > 0).and.(xnPosR > 0)
			xnPos=min(xnPosS, xnPosR)                 && pozice 1. oddelovace
		case (xnPosS = 0).and.(xnPosR > 0)
			xnPos=xnPosR
		case (xnPosS > 0).and.(xnPosR = 0)
			xnPos=xnPosS
		otherwise
			xnPos=0
	EndCase

	xcOrigLineKey=(iif(xnPos > 0, left(xcR, xnPos-1), xcR))  && key (Par nebo Sect)
	xcLineKey=Upper(xcOrigLineKey)  && key (Par nebo Sect)

	If (left(xcLineKey,1)==mkSectLeft).and.(right(xcLineKey,1)==mkSectRight)	&& nalezena nejaka sekce
		if xlSectionFound		&& spravna sekce uz byla, tohle je dalsi, uz nehledat
		exit
	endif
	xcSection=substr(xcLineKey, 2, len(xcLineKey)-2)
	if (xcSection==xcSectname)
		xlSectionFound=.T.
		xnSectionPos=xnI
	endif
	loop
Endif

if (xcLineKey==xcParName).and.xlSectionFound		&& nalezen parametr i sekce
		xaLines[xnI]=xcOrigLineKey+[ = ]+pxValue+[ ; changed by program ]+TtoC(datetime())
		xlAppend=.F.
		exit
endif

ENDFOR

xcR=[]
DO CASE
	CASE .not.xlAppend			&& klic ve spravne sekci nalezen
		FOR xnI=1 to xnLines
			xcR=xcR+xaLines[xnI]+CRLF
		ENDFOR
	CASE xlAppend.and.xlSectionFound			&& sekce nalezena, klic nenalezen
		FOR xnI=1 to xnLines				&& poskladani pole do retezce
			xcR=xcR+xaLines[xnI]+CRLF
			If xnI=xnSectionPos			&& vlozeni noveho Parametru za zahlavi sekce
				xcR=xcR+pcParName+[ = ]+pxValue+[ ; inserted by program ]+TtoC(datetime())+CRLF
			EndIf
		ENDFOR
	CASE xlAppend.and..not.xlSectionFound			&& sekce ani klic nenalezeny
		FOR xnI=1 to xnLines				&& poskladani pole do retezce
			xcR=xcR+xaLines[xnI]+CRLF
		ENDFOR
		xcR=xcR+CRLF+mkSectLeft+pcSectname+mkSectRight+[ ; inserted by program ]+TtoC(datetime())+CRLF	&& doplneni sekce
		xcR=xcR+pcParName+[ = ]+pxValue+[ ; inserted by program]+CRLF						&& doplneni parametru
ENDCASE

RETURN (StrToFile(xcR, pcINIfile, .F.) > 0)
